// GLog.cpp: implementation of the CGLog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VCTest.h"
#include "GLog.h"
#include "atlbase.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#include "SystemLog_i.c"
#include "SystemLog_i.h"

CGLog::CGLog()
{
	InitCom();
}

CGLog::~CGLog()
{
	if(m_pIntLog)
	{
		m_pIntLog->Release();
		::CoUninitialize();
		m_pIntLog = NULL;
	}
}

void CGLog::LogOut(LPCTSTR p_pstrLogStr, ...)
{
	if(m_pIntLog)
	{
		CComBSTR cbstrLogStr;
		long lRet;

		va_list args;
		va_start(args, p_pstrLogStr);
		_vsnprintf(m_pBuf , 4000, p_pstrLogStr , args);

		cbstrLogStr = m_pBuf;
		m_pIntLog->LogOut(cbstrLogStr.m_str , 0 , &lRet);
		va_end(args);
	}
}

CGLog::CGLog(LPCTSTR p_lptPath, LPCTSTR p_lptFile, LPCTSTR p_lptModule, LPCTSTR p_lptOutLevel, LPCTSTR p_lptLinesToFile, LPCTSTR p_lptClearState)
{
	InitCom();

	CComBSTR cbstrRequest;

	cbstrRequest  = "<Logout>";

	cbstrRequest += "<SetPath>";
	cbstrRequest += p_lptPath;
	cbstrRequest += "</SetPath>";

	cbstrRequest += "<SetFile>";
	cbstrRequest += p_lptFile;
	cbstrRequest += "</SetFile>";

	cbstrRequest += "<SetModule>";
	cbstrRequest += p_lptModule;
	cbstrRequest += "</SetModule>";

	cbstrRequest += "<SetLevel>";
	cbstrRequest += p_lptOutLevel;
	cbstrRequest += "</SetLevel>";

	cbstrRequest += "<SetLine>";
	cbstrRequest += p_lptLinesToFile;
	cbstrRequest += "</SetLine>";

	cbstrRequest += "<SetClear>";
	cbstrRequest += p_lptClearState;
	cbstrRequest += "</SetClear>";

	cbstrRequest += "</Logout>";

	if(m_pIntLog)
	{
		long lRet = 0;

		m_pIntLog->SetInfo(SET_INFO , cbstrRequest.m_str , &lRet);
	}
}

void CGLog::InitCom()
{
	m_pIntLog = NULL;

	::CoInitialize(NULL);

	HRESULT hr;   
	hr = CoCreateInstance(CLSID_ModuleLog, NULL, CLSCTX_SERVER , 
		IID_IModuleLog, (void **)& m_pIntLog);
	if(!SUCCEEDED(hr))
	{
		m_pIntLog = NULL;
		return;
	}
}
